@ECHO OFF

::Emsisoft Command Line Update version 1.2
::Can be used to install updates regardless of whether or not Emsisoft Anti-Malware or Emsisoft Internet Security are running.

::Check if we have admin rights.
ICACLS "%SYSTEMROOT%\system32\config\system"
IF ERRORLEVEL 1 (GOTO PromptForAdmin) ELSE (GOTO ContinueProcessing)

::Code to launch VBS that prompts for Admin rights.
:PromptForAdmin
ECHO Set UAC = CreateObject^("Shell.Application"^) >> %TEMP%\Emsisoft_Diagnostic_UAC_Popup.vbs
ECHO UAC.ShellExecute "%~s0", "", "", "runas", 1 >> %TEMP%\Emsisoft_Diagnostic_UAC_Popup.vbs
CSCRIPT.EXE %TEMP%\Emsisoft_Diagnostic_UAC_Popup.vbs
EXIT /B

::Delete VBScript file used for UAC prompt, and continue processing rest of code.
:ContinueProcessing
DEL /F /Q %TEMP%\Emsisoft_Diagnostic_UAC_Popup.vbs

ECHO Emsisoft Command Line Update version 1.2
ECHO.
ECHO Attempting to determine which Emsisoft product is installed ...

::Attempt to determine path of installed Emsisoft product automatically:
FOR /F "tokens=2 delims==" %%F IN ('WMIC /namespace:\\root\SecurityCenter2 PATH AntiVirusProduct WHERE "displayName like 'Emsisoft%%'" GET pathToSignedReportingExe /value ^| FIND "="') DO SET "EmsiProductDir=%%F"
SET A2CMD_PATH=%EmsiProductDir:~0,-15%

::Test if detected folder actually exists, and if so then skip to running update.
IF EXIST A2CMD_PATH (GOTO RunUpdate)

::If detected folder does not exist, then attempt to find the correct folder through trial and error.
CLS
ECHO Emsisoft Command Line Update version 1.2
ECHO.
ECHO Attempting to update using command line ...

IF EXIST "%ProgramFiles%\Emsisoft Anti-Malware\a2cmd.exe" (
	SET A2CMD_PATH="%ProgramFiles%\Emsisoft Anti-Malware"
	GOTO RunUpdate
)

IF EXIST "%ProgramFiles%\Emsisoft Internet Security\a2cmd.exe" (
	SET A2CMD_PATH="%ProgramFiles%\Emsisoft Internet Security"
	GOTO RunUpdate
)

IF EXIST "%ProgramFiles(x86)%\Emsisoft Anti-Malware\a2cmd.exe" (
	SET A2CMD_PATH="%ProgramFiles(x86)%\Emsisoft Anti-Malware"
	GOTO RunUpdate
)

IF EXIST "%ProgramFiles(x86)%\Emsisoft Internet Security\a2cmd.exe" (
	SET A2CMD_PATH="%ProgramFiles(x86)%\Emsisoft Internet Security"
	GOTO RunUpdate
)

::If the correct folder can not be found, then display error message, and skip to end.
CLS
ECHO Unable to find A2CMD.EXE
ECHO Detected path to A2CMD.EXE is as follows:
ECHO %A2CMD_PATH%\a2cmd.exe
ECHO.
ECHO Please contact Emsisoft Support, and let them know the above path and that
ECHO A2CMD.EXE could not be found.
ECHO.
GOTO EXIT

:RunUpdate
CLS
ECHO Emsisoft Command Line Update version 1.2
ECHO.
CD %A2CMD_PATH%

::Attempt to determine if a2service.exe is running.
FOR /F "tokens=2 delims==" %%F IN ('WMIC SERVICE WHERE "Name='a2AntiMalware'" GET State /value ^| FIND "="') DO SET "a2serviceState=%%F"

::If a2service.exe is running, then run update with /s parameter to use service, otherwise run it without /s parameter.
IF %a2serviceState% == Running (A2CMD.EXE /s /u) ELSE (A2CMD.EXE /u)
ECHO.
ECHO.

:EXIT
PAUSE